from flask import request
from flask_restx import Resource, Namespace, reqparse

from app.defines import StatesCode

ns = Namespace('role', description='角色管理接口')


@ns.route('/role_list')
class GetUserListApi(Resource):
    @ns.doc(id='get_role_list', description='获取角色列表')
    @ns.expect()
    def get(self):
        """获取角色列表"""
        status = request.args.get('status')
        page_size = int(request.args.get('page_size', 20))
        page = int(request.args.get('page', 1))
        data = [
            {"name": "admin", "message": "1111", "member": 100, "relationship_groups": 1},
            {"name": "admin1", "message": "2222", "member": 200, "relationship_groups": 2},
            {"name": "admin1", "message": "3333", "member": 300, "relationship_groups": 3},

        ]
        return {"code": StatesCode.SUCCESS, "message": "成功", "data": data}


@ns.route('/role')
class RoleApi(Resource):
    @ns.doc(id='get_role', description='搜索角色')
    @ns.expect()
    def get(self):
        """查询角色"""
        data = {
            "name": "决策组",
            # "describe":"xxxxx",
            # "移动端":{
            #
            # },
            # "pc端":{
            #     "前段":[],
            #     "后段":[]
            # },
            # "member":[]

        }
        return {"code": StatesCode.SUCCESS, "message": "成功", "data": data}

    @ns.doc(id='add_role', description='添加角色')
    @ns.expect()
    def post(self):
        """添加角色"""
        return {"code": StatesCode.SUCCESS, "message": "成功", "data": "添加成功"}

    @ns.doc(id='modify_role', description='修改角色')
    @ns.expect()
    def put(self):
        return {"code": StatesCode.SUCCESS, "message": "成功", "data": "修改成功"}

    @ns.doc(id='delete_role', description='删除角色')
    @ns.expect()
    def delete(self):
        """删除角色"""
        return {"code": StatesCode.SUCCESS, "message": "成功", "data": "删除成功"}


@ns.route('/role_permission')
class RolePermissionApi(Resource):
    @ns.doc(id='get_role_permission', description='获取角色权限')
    @ns.expect()
    def get(self):
        """获取权限列表"""
        data = {
            "前端": {

            },
            "后端": {

            }

        }
        return {"code": StatesCode.SUCCESS, "message": "成功", "data": data}


@ns.route('/member_list')
class RoleMemberApi(Resource):
    @ns.doc(id='get_role_member', description='获取角色成员')
    @ns.expect()
    def get(self):
        """获取角色成员"""
        data = {
            'id': '1',
            'name': '张三',
            'modle': '13999999999',
            'email': '123@test.com',
            'organization': '北京',
            'register_time': '2020-10-01',
            'status': 1,

        }
        return {"code": StatesCode.SUCCESS, "message": "成功", "data": data}
